/////////////////////////////////////////////////
// (c) 1997 Jake Birkett ... uses allegro library
/////////////////////////////////////////////////
// C++ Source Code
//
// WingWang V1.0 ... ww1.exe
//
// OR Operator ||
//
#include <stdlib.h>
#include <stdio.h>
#include <bios.h>


#include "allegro.h"

#define WIDTH			320
#define HEIGHT			200

#define MAX_AMMO_TYPES          4       // num of ammo types available to ship
#define MAX_AMMO		100
#define MAX_AMMO_POWER		4	// num of available ammo sizes
#define MAX_AMMO_POWERUP	5	// num of available ammo powerups

#define MAX_ALIEN_TYPES		14
#define MAX_ALIEN_FRAMES	8	// max num of frames in alien animation
#define MAX_ALIENS		100	// on screen at once
#define MAX_AA_TYPES            3       // max num of types of alien ammo
#define MAX_ALIEN_AMMO          50      // on screen at once
#define MAX_ALIEN_AMMO_FRAMES   4       // max num of frames in alien ammo animation

#define MAX_EXP_TYPES		8	// num of explosion animations
#define MAX_EXP_FRAMES		8	// max num of frames in explosion animation
#define MAX_POW_BMPS		9       // num of powerup graphics tiles
#define MAX_POWS		5	// max num of powerups visible on screen

#define MAX_MAP_WIDTH           10
#define MAX_MAP_HEIGHT          100

#define MAX_SAMPLES		13
//// FILES ////////

char pcx_name[80]={			"game.pcx"};
char exp_pcx_name[80]={			"explo1.pcx"};
char alien_pcx_name[80]={		"aliens1.pcx"};
char tiles_name[80]={			"tiles1.pcx"};


char sample_name[MAX_SAMPLES][80]={	"fire0.wav",
					"fire1.wav",
					"fire2.wav",
					"fire3.wav",
					"fire4.wav",
					"fire5.wav",
					"fire6.wav",
					"fire7.wav",
					"fire8.wav",
					"fire9.wav",
					"fire10.wav",
					"fire11.wav",
					"fire12.wav"};
///////////////////

PALLETE pcx_pallete;
PALLETE tiles_pallete;
BITMAP *pcx_buffer;
BITMAP *exp_buffer;
BITMAP *alien_buffer;
BITMAP *tiles;
BITMAP *scr; // buffer used to constuct screen image
//BITMAP *bmp=NULL;
BITMAP *ship_bmp=NULL;
BITMAP *ship_hitbmp=NULL;
BITMAP *ship_invunbmp=NULL;
BITMAP *ammo_bmp[MAX_AMMO_TYPES][MAX_AMMO_POWER];
BITMAP *alien_bmp[MAX_ALIEN_TYPES][MAX_ALIEN_FRAMES];
BITMAP *alien_hitbmp[MAX_ALIEN_TYPES]; // alien hit flash bitmap
BITMAP *aa_bmp[MAX_AA_TYPES][MAX_ALIEN_AMMO_FRAMES]; // alien ammo bitmap animations
BITMAP *exp_bmp[MAX_EXP_TYPES][MAX_EXP_FRAMES];
BITMAP *pow_bmp[MAX_POW_BMPS];

SAMPLE *gamesound[MAX_SAMPLES]; // holds all sound effects
///////////////////

struct ship_type{
  fix xvel; //velocity
  fix yvel;
  fix xdec;
  fix ydec; // deceleration

} ship;

int testvideo_loop = 1000;
int testcpu_loop = 100;

char map[MAX_MAP_WIDTH];
char *map_ptr; // points to current map coord

int lastkey; // last key read from keyboard buffer
int framecount=0;

int i=0; // generic counter variable
int n=0; // generic counter variable
int num=0;
int index=0;
int loop=0;
int col=0; // used for coloured bars
fixed result = 0; //used to store result of fixed point calculations

int pan=128; // use for playing samples

char itoa_str[33]; // used to store output string of itoa function
char buf[64];      // used to store output of sprintf function

int cx=0; // cursor x in pixels
int cy=0; // cursor y in pixels

long fsize=0;
char fname[20]="lev1.dat";

int frames=0; // number of frames elapsed
long last_ticks=0; // used to calc ticks per frame
long ticks=0; // number of clock ticks (18.2/sec) since midnight
RGB col_black		= {0, 0, 0};
RGB col_white		= {63, 63, 63};
RGB col_red		= {63, 0, 0}; // buffer -> vga
RGB col_green		= {0, 63, 0}; // tiles -> buffer
RGB col_blue		= {0, 0, 63}; // text output
RGB col_yellow		= {63, 63, 0}; // sprite output
RGB col_purple		= {63, 0, 63}; // sprite output
RGB col_work		= {0,0,0}; // working colour used for cycling
RGB col_work2		= {0,0,0}; // working colour used for cycling

int keyr_hada0=0; // used to force user to releae key r before pressing it again
int show_raster = 0;
int paused = 0; // if 1 then game is paused but ESCAPE still works
int paused_hada0 = 0; // forces the uses to actually type the P key
int paused_control_hada0 = 0; // forces the uses to actually type the CONTROL key to get out of pause
int slow_motion=0;
int pow_cheat=0; // 1 generates a pow after every alien kill
int score=0;
int lives=3;
int autofire=0;
int max_autofire=500; // max number of autofire shots
int scroll_x=0;
int scroll_y=0;

//ship variables
int ship_x=0;
int ship_y=0;
int ship_speed=2; // current speed level
int ship_startspeed=2;
int ship_maxspeed=6;
int ship_width=32;
int ship_height=32;
int ship_shield=100; // current shield level
int max_shield=100; // highest level shield can reach
int ship_hull=100; // current hull level
int max_hull=100; // highest level hull can reach
int ship_hit=0;
int ship_exp=0; // points to ship exp animation pattern frame
int ship_exp_anim=5; // points to the exp animation type used by the ship
int ship_framecount=0; // used to slow down animations
int ship_leeway=4; // number of pixels leeway ship is given in collision detection
int ship_invun_length=400; // in frames
int ship_invun_count=0; // 0=not invunerable
int ship_coloffset=0; // colour offset giving the colour cycle
RGB ship_col[4]={0,0,0,0,0,0,0,0,0,0,0,0}; // used for invunerability colour cycling
int ship_ammotype=0;

//ship sounds
int ship_firesound=1;
int ship_hitsound=0;
int ship_expsound=6;
int ship_powsound=7;
int ship_autosound=8;
int autofire_musicpitch=250;
int ship_invunsound=12;
int ship_invun_musicpitch=250;

//pixel perfect collision detection variables
int damage_shield=0; // set to the level of damage wished to be done
int damage_hull=0;   // set to the level of damage wished to be done
int x=0;
int y=0;
int dx=0;
int dy=0;
int scan_width=0;
int scan_height=0;
int scan_shipx=0;
int scan_shipy=0;
int scan_alienx=0;
int scan_alieny=0;
int scan_alienwidth=0;
int scan_alienheight=0;
BITMAP *test_bmp=NULL; // this is only a pointer, it is never created
// PP ammo extra variables
int pp_ammowidth=0;
int pp_ammoheight=0;
int pp_ammox=0;
int pp_ammoy=0;

// alien quick integers
int a=0;
int ax=0;
int ay=0;

// alien type arrays
int alien_anim_speed[MAX_ALIEN_TYPES]={2,3,4,5,6,7,8,9,5,10,15,15,5,5}; // 1 = very fast
int alien_radius=25; // rotation diameter
int alien_type_exp[MAX_ALIEN_TYPES]={0,1,2,3,4,5,6,7,1,3,4,5,3,3};
int alien_type_energy[MAX_ALIEN_TYPES]={1,2,4,6,10,15,20,30,4,8,12,16,5,8};
int at_ammo[MAX_ALIEN_TYPES]={-1,-1,-1,-1,-1,-1,-1,-1,0,0,1,2,0,0}; // -1=no ammo
int at_ammo_speed[MAX_ALIEN_TYPES]={-1,-1,-1,-1,-1,-1,-1,-1,2,2,1,1,3,2};
int alien_frames[MAX_ALIEN_TYPES]={8,8,8,8,8,8,1,1,4,4,4,4,4,4}; // num of frames in alien animation
int at_firesound[MAX_ALIEN_TYPES]={0,0,0,0,0,0,0,0,10,10,10,10,10,10};
int at_hitsound[MAX_ALIEN_TYPES]={2,2,2,2,2,2,2,2,2,2,2,2,2,2};
int at_expsound[MAX_ALIEN_TYPES]={11,11,11,11,11,11,11,11,11,11,11,11,11,11};
int atx[MAX_ALIEN_TYPES]={0,0,0,0,0,0,0,192,0,0,0,0,160,320}; // x coord of first tile on pcx file
int aty[MAX_ALIEN_TYPES]={0,8,24,48,80,128,192,192,304,320,352,400,320,400}; // y coord of first tile on pcx file
int asx[MAX_ALIEN_TYPES]={8,16,24,32,48,64,96,128,16,32,48,64,32,64}; // width of alien frame
int asy[MAX_ALIEN_TYPES]={8,16,24,32,48,64,96,128,16,32,48,64,32,64}; // height of alien frame
int alien_damage_shield=2;
int alien_damage_hull=2;

// screen alien arrays
int alien_hit_speed=2;  // num of frames that hit tile will show for
int alien_stack[MAX_ALIENS]; // contains the draw order for the aliens
int alien_stack_ptr=0; // holds the next empty alien stack index
int li=0; // alien index
int alien_type[MAX_ALIENS]; // index to alien_bmp[array]
int alien_sizex[MAX_ALIENS]; // width of alien in pixels
int alien_sizey[MAX_ALIENS]; // height of alien in pixels
int alien_frame[MAX_ALIENS]; // animation frame 0 based
int alien_framecount[MAX_ALIENS]; // animation frame delay counter
int alien_alive[MAX_ALIENS]; // 1=alive
int alien_energy[MAX_ALIENS]; // 0 = dead
int alien_hit[MAX_ALIENS]; // 1 = show hit tile
int alien_hitcount[MAX_ALIENS]; // hit bitmap delay counter
int alien_exp[MAX_ALIENS]; // pointer to alien exp animation frame
int alien_x[MAX_ALIENS];
int alien_y[MAX_ALIENS];
int alien_startx[MAX_ALIENS];
int alien_starty[MAX_ALIENS];
int alien_speed[MAX_ALIENS];
fixed alien_angle[MAX_ALIENS];
int alien_firerate = 250; // 1 = very fast
int offsetx=0; // used in alien->ammo collision detection
int offsety=0; // used in alien->ammo collision detection

// alien ammo type arrays
int aa_tx[MAX_AA_TYPES]={0,0,0};
int aa_ty[MAX_AA_TYPES]={192,200,216};
int aa_type_sizex[MAX_AA_TYPES]={8,16,24};
int aa_type_sizey[MAX_AA_TYPES]={8,16,24};
int aa_type_exp[MAX_AA_TYPES]={0,1,2};
int aa_tframes[MAX_AA_TYPES]={4,4,4};
int aa_damage_shield[MAX_AA_TYPES]={10,20,30};
int aa_damage_hull[MAX_AA_TYPES]={10,20,30};

// screen alien ammo arrays ... this is separate from the screen alien arrays
int aa_anim_speed=5; // 1 = very fast
int aa=0; // general alien ammo integer
int aa_stack[MAX_ALIEN_AMMO]; // contains the draw order for the aliens
int aa_stack_ptr=0; // holds the next empty alien stack index
int aai=0; // alien ammo index
fixed hyp=0; // used in alien ammo trajectory calculation
fixed adx=0;
fixed ady=0;
int aa_x[MAX_ALIEN_AMMO]; // alien ammo x coord
int aa_y[MAX_ALIEN_AMMO]; // alien ammo y coord
int aa_dx[MAX_ALIEN_AMMO]; // alien ammo x error term delta
int aa_dy[MAX_ALIEN_AMMO]; // alien ammo y error term delta
int aa_ex[MAX_ALIEN_AMMO]; // alien ammo x error term
int aa_ey[MAX_ALIEN_AMMO]; // alien ammo y error term
int aa_ecx[MAX_ALIEN_AMMO]; // alien ammo x error term compare
int aa_ecy[MAX_ALIEN_AMMO]; // alien ammo y error term compare
int aa_xdir[MAX_ALIEN_AMMO]; // -1=left 1=right
int aa_ydir[MAX_ALIEN_AMMO]; // -1=up 1=down

int aa_alive[MAX_ALIEN_AMMO]; // 1=alien ammo is active
int aa_type[MAX_ALIEN_AMMO]; // type of alien ammo
int aa_sizex[MAX_ALIEN_AMMO]; // width in pixels
int aa_sizey[MAX_ALIEN_AMMO]; // height in pixels
int aa_frame[MAX_ALIEN_AMMO]; // pointer to anim frame ... 0 zero based
int aa_framecount[MAX_ALIEN_AMMO];
int aa_exp[MAX_ALIEN_AMMO]; // pointer to alien ammo exp animation frame
int aa_speed[MAX_ALIEN_AMMO];

//explosions
int exp_anim_speed=2; // 1 = very fast
int exp_frames[MAX_EXP_TYPES]={8,8,8,8,8,8,8,8}; // num of frames in exp animation
int etx[MAX_EXP_TYPES]={0,0,0,0,0,0,0,0};  // x coord of first tile on pcx file
int ety[MAX_EXP_TYPES]={0,8,24,48,80,128,192,288};  // y coord of first tile on pcx file
int esx[MAX_EXP_TYPES]={8,16,24,32,48,64,96,128}; // width of exp frame
int esy[MAX_EXP_TYPES]={8,16,24,32,48,64,96,128}; // height of exp frame

//powerups
int pow=0; // pow index
int pow_alive[MAX_POWS];
int pow_type[MAX_POWS];
int pow_x[MAX_POWS];
int pow_y[MAX_POWS];
int pow_framecount=0;
int pow_coloffset=0; // colour offset giving the colour cycle
RGB pow_col[4]={0,0,0,0,0,0,0,0,0,0,0,0};
int last_pow=0; // last powerup collected ... used to show on screen label
int last_pow_col=0; // colour of label ... if it's 0 then label is not drawn
int last_pow_framecount=0; // used to slow down label fade out
int last_pow_speed=8; //number of frames before label colour fades 1 unit
char last_pow_string[MAX_POW_BMPS][17]={"AUTOFIRE",    // Red
                                        "SHIELD",      // Green
                                        "HULL",        // Blue
                                        "LARGER AMMO", // Magenta
                                        "WIDER AMMO",  // Cyan
                                        "FASTER AMMO", // Yellow
                                        "SPREAD AMMO", // White
                                        "INVUNERABLE", // Orange
                                        "FASTER SHIP"};// Light Green

// screen ammo arrays
int ammo_stack[MAX_AMMO]; // contains the draw order for the ammo
int ammo_stack_ptr=0; // holds the next empty ammo stack index
int ai=0; // ammo index
int ammo_type[MAX_AMMO];
int ammo_powerlevel[MAX_AMMO];
int ammo_sizex[MAX_AMMO];
int ammo_sizey[MAX_AMMO];
int ammo_alive[MAX_AMMO];
int ammo_x[MAX_AMMO];
int ammo_y[MAX_AMMO];
int ammo_speed[MAX_AMMO];
int ammo_framecount[MAX_AMMO]; // ammo explosion anim delay counter
int ammo_exp[MAX_AMMO]; // ammo explosion frame
int ammo_spread[MAX_AMMO]; // 0=no spread 1=right -1=left
int ammo_spread_errorterm[MAX_AMMO]; // keeps track of when to spread
int ammo_spread_delta[MAX_AMMO]; // larger = more spread

// ammo environment varables
int ammo_curspeed=2; // current ammo speed level
int ammo_startspeed=2;
int ammo_maxspeed=16;
int ammo_power=0; // determines size of ammo 8,16,32
int ammo_powerup=0; // determines ammo powerup level
int ammo_refirestart=12; // number of frames between refire
int ammo_refirelevel=12; // level that counter must reach before refiring
int ammo_refire_counter=0; // if counter>0 then ship cannnot refire
int ammo_pitchstart=100; // starting pitch of firing
int ammo_pitch=100; // actual current pitch of firing
int ammo_pitchrise=20; // rise in pitch between each ammo fired
int ammo_control_hada0 = 0; // set to 1 when the CONROL key is lifted up
int ammo_spread_enabled = 0; // 0=off ... 1=on

// ammo type arrays
int ammo_size[MAX_AMMO_POWER]={8,16,24,32};
int ammo_offsetx[MAX_AMMO_POWER]={12,8,4,0};
int ammo_offsety[MAX_AMMO_POWER]={-8,-16,-24,-32};
int ammo_type_exp[MAX_AMMO_POWER]={0,1,2,3};
int ammo_numammos[MAX_AMMO_POWERUP]={1,2,3,4,5}; // num of ammos released in each pattern
//  0 = no spread
//  1 = spread right
// -1 = spread left
int ammo_type_spread[MAX_AMMO_POWERUP][5] = {0,0,0,0,0,
                                             -1,1,0,0,0,
                                             0,-1,1,0,0,
                                             -1,1,-2,2,0,
                                             0,-1,1,-2,2};
int ammo_patternx[MAX_AMMO_POWERUP][MAX_AMMO_POWER*5]=	{0,0,0,0,0,
							 0,0,0,0,0,
							 0,0,0,0,0,
                                                         0,0,0,0,0,
							 -4,4,0,0,0,
							 -8,8,0,0,0,
                                                         -12,12,0,0,0,
							 -16,16,0,0,0,
							 0,-6,6,0,0,
							 0,-12,12,0,0,
                                                         0,-18,18,0,0,
							 0,-24,24,0,0,
							 -4,4,-10,10,0,
							 -8,8,-20,20,0,
                                                         -12,12,-30,30,0,
							 -16,16,-40,40,0,
							 0,-7,7,-12,12,
							 0,-14,14,-24,24,
                                                         0,-21,21,-36,36,
							 0,-28,28,-48,48};
int ammo_patterny[MAX_AMMO_POWERUP][MAX_AMMO_POWER*5]=	{0,0,0,0,0,
							 0,0,0,0,0,
							 0,0,0,0,0,
                                                         0,0,0,0,0,
							 0,0,0,0,0,
							 0,0,0,0,0,
							 0,0,0,0,0,
                                                         0,0,0,0,0,
							 0,3,3,0,0,
							 0,6,6,0,0,
                                                         0,9,9,0,0,
							 0,12,12,0,0,
							 0,0,4,4,0,
							 0,0,8,8,0,
                                                         0,0,12,12,0,
							 0,0,16,16,0,
                                                         0,2,2,8,8,
                                                         0,4,4,16,16,
                                                         0,6,6,24,24,
                                                         0,8,8,32,32};

/////////////////////////////
// FUNCTIONS
/////////////////////////////
void Game_Exit(void){
  return;
//buffers
  destroy_bitmap(tiles);
  destroy_bitmap(scr);
//  destroy_bitmap(bmp);
  //ship
  destroy_bitmap(ship_bmp);
  destroy_bitmap(ship_hitbmp);
  destroy_bitmap(ship_invunbmp);
  //ammo
  for (index=0;index<MAX_AMMO_TYPES;index++)
      for (i=0; i<MAX_AMMO_POWER; i++)
          destroy_bitmap(ammo_bmp[index][i]);
  //aliens
  for (index=0; index<MAX_ALIEN_TYPES; index++){
    destroy_bitmap(alien_hitbmp[index]);
    for (i=0; i<alien_frames[index]; i++)
      destroy_bitmap(alien_bmp[index][i]);
  }
  //alien ammo
  for (index=0;index<MAX_AA_TYPES;index++)
      for (i=0; i<aa_tframes[index]; i++)
          destroy_bitmap(aa_bmp[index][i]);
  //explosions
  for (index=0; index<MAX_EXP_TYPES; index++)
    for (i=0; i<exp_frames[index]; i++)
      destroy_bitmap(exp_bmp[index][i]);
  //powerups
  for (i=0; i<MAX_POW_BMPS; i++)
      destroy_bitmap(pow_bmp[MAX_POW_BMPS]);


  //samples
  for (i=0;i<MAX_SAMPLES;i++)
      destroy_sample(gamesound[i]);

  allegro_exit();
}
/////////////////////////////
void Show_FPS(void){
  frames++;
  ticks = biostime(0, 0);
  itoa(ticks, itoa_str, 10);
  textout(screen, font, itoa_str, 200, 0, 1);
  if (ticks>=last_ticks)
  {
    itoa(frames, itoa_str, 10);
    textout(screen, font, itoa_str, 0, 20, 1);
    textout(screen, font, "fps", 0, 20, 1);
    last_ticks = ticks+18;
    frames = 0;
  }
}
/////////////////////////////
void Grab_Sprites(){
  //grabs various game objects from pcx_buffer

  //ship
  ship_bmp = create_bitmap(32,32);
  blit(pcx_buffer,ship_bmp,32,0,0,0,32,32);
  ship_hitbmp = create_bitmap(32,32);
  blit(pcx_buffer,ship_hitbmp,64,0,0,0,32,32);
  ship_invunbmp = create_bitmap(32,32);
  blit(pcx_buffer,ship_invunbmp,96,0,0,0,32,32);

  //ammo
  for (index=0;index<MAX_AMMO_TYPES;index++){
      n=0;
      for (i=0; i<MAX_AMMO_POWER; i++){
          ammo_bmp[index][i] = create_bitmap(ammo_size[i],ammo_size[i]);
          blit(pcx_buffer,ammo_bmp[index][i],n,64+index*32,0,0,ammo_size[i],ammo_size[i]);
          n+=ammo_size[i];
          }
  }

  //aliens
  for (index=0; index<MAX_ALIEN_TYPES; index++){
    ax=asx[index];
    ay=asy[index];
    alien_hitbmp[index] = create_bitmap(ax,ay);
    blit(alien_buffer,alien_hitbmp[index],atx[index],aty[index],0,0,ax,ay);
    for (i=0; i<alien_frames[index]; i++){
      alien_bmp[index][i] = create_bitmap(ax,ay);
      blit(alien_buffer,alien_bmp[index][i],atx[index]+ax+i*ax,aty[index],0,0,ax,ay);
    }
  }

  //alien ammo animations
  for (index=0;index<MAX_AA_TYPES;index++)
      for (i=0; i<aa_tframes[index]; i++){
          aa_bmp[index][i]=create_bitmap(aa_type_sizex[index],aa_type_sizey[index]);
          blit(pcx_buffer,aa_bmp[index][i],aa_tx[index]+i*aa_type_sizex[index],aa_ty[index],0,0,aa_type_sizex[index],aa_type_sizey[index]);
      }

  //explosions
  for (index=0; index<MAX_EXP_TYPES; index++)
    for (i=0; i<exp_frames[index]; i++){
      exp_bmp[index][i] = create_bitmap(esx[index],esy[index]);
      blit(exp_buffer,exp_bmp[index][i],etx[index]+i*esx[index],ety[index],0,0,esx[index],esy[index]);
    }

  //powerups
  for (i=0; i<MAX_POW_BMPS; i++){
    pow_bmp[i] = create_bitmap(32,32);
    blit(pcx_buffer,pow_bmp[i],i*32,32,0,0,32,32);
  }

  //destroy buffers
  destroy_bitmap(pcx_buffer);
  destroy_bitmap(exp_buffer);
  destroy_bitmap(alien_buffer);

}
/////////////////////////////
void Draw_Sprites(void){
  if (show_raster) set_color(0, &col_yellow);
  //draw all aliens
  for (i=0; i<alien_stack_ptr; i++){
    li=alien_stack[i];
    if (alien_hit[li]>0){
       if (alien_exp[li]>0){
          //draw explosion
          index = alien_type_exp[alien_type[li]];
          draw_sprite(scr,exp_bmp[index][alien_exp[li]-1],alien_x[li],alien_y[li]);
       }
       else
         // draw alien hit flash
         draw_sprite(scr,alien_hitbmp[alien_type[li]],alien_x[li],alien_y[li]);
    }
    else
       draw_sprite(scr,alien_bmp[alien_type[li]][alien_frame[li]],alien_x[li],alien_y[li]);
  }

  if (show_raster) set_color(0, &col_white);
  //draw all ammo
  for (i=0; i<ammo_stack_ptr; i++){
    ai=ammo_stack[i];
    if (ammo_exp[ai]>0){
       //draw ammo explosion}
       index = ammo_type_exp[ammo_powerlevel[ai]];
       draw_sprite(scr,exp_bmp[index][ammo_exp[ai]-1],ammo_x[ai],ammo_y[ai]);
    }
    else
       draw_sprite(scr,ammo_bmp[ammo_type[ai]][ammo_powerlevel[ai]],ammo_x[ai],ammo_y[ai]);
  }

  //draw ship
  if (ship_exp>0)
     draw_sprite(scr, exp_bmp[ship_exp_anim][ship_exp-1], ship_x-16, ship_y-16);
  else
  if (ship_hit>0){
     // draw ship hit flash
     if (ship_hit==1){
        ship_hit=2;
        draw_sprite(scr, ship_hitbmp, ship_x, ship_y); // flash on
     }
     else {
        ship_hit=0;
        draw_sprite(scr, ship_bmp, ship_x, ship_y); // flash off
     }
  }
  else
  if (ship_invun_count>0)
     draw_sprite(scr, ship_invunbmp, ship_x, ship_y);
  else
     draw_sprite(scr, ship_bmp, ship_x, ship_y);

  //draw pows
  for (i=0;i<MAX_POWS;i++){
    if (pow_alive[i])
       draw_sprite(scr,pow_bmp[pow_type[i]],pow_x[i],pow_y[i]);
  }

  //draw alien ammo
  for (aa=0;aa<aa_stack_ptr;aa++){
      aai=aa_stack[aa];
      if (aa_exp[aai]>0){
         //draw alien ammo explosion}
         index = aa_type_exp[aa_type[aai]];
         draw_sprite(scr,exp_bmp[index][aa_exp[aai]-1],aa_x[aai],aa_y[aai]);
      }
      else
         draw_sprite(scr,aa_bmp[aa_type[aai]][aa_frame[aai]],aa_x[aai],aa_y[aai]);
  }
}
/////////////////////////////
void Game_Start(void){
  score=0;
  ammo_curspeed = ammo_startspeed;
  ammo_power = 0;
  ammo_powerup = 0;
  ship_speed = ship_startspeed;
  ship_ammotype=0;

  ship_col[0].r=0;
  ship_col[0].g=24;
  ship_col[0].b=24;
  ship_col[1].r=0;
  ship_col[1].g=32;
  ship_col[1].b=32;
  ship_col[2].r=0;
  ship_col[2].g=48;
  ship_col[2].b=48;
  ship_col[3].r=0;
  ship_col[3].g=63;
  ship_col[3].b=63;
}
/////////////////////////////
void Ship_Init(void){ // called after ship has exploded
  ship.xdec=0.1;
  ship.ydec=0.1;

  autofire = 0;
  ship_x = WIDTH/2;
  ship_y = HEIGHT-ship_height-8; // 8 is for scroreboard
  ship_shield = max_shield;
  ship_hull = max_hull;
  ship_hit = 0;
  ship_exp = 0;
  ship_framecount=0;
  ship_invun_count=ship_invun_length;
  ship_coloffset=0;
  ammo_spread_enabled = 0;

  stop_sample(gamesound[ship_autosound]);
  stop_sample(gamesound[ship_invunsound]);
  play_sample(gamesound[ship_invunsound],255,pan,ship_invun_musicpitch,FALSE);
}
/////////////////////////////
void Ship_Degrade(void){
  // ship speed
  if (ship_speed>ship_startspeed)
     ship_speed-=2;
  //ammo speed
  if (ammo_curspeed>ammo_startspeed)
      ammo_curspeed-=2;
  if (ammo_curspeed<ship_speed)
     ammo_curspeed=ship_speed;
  // ammo power
  if (ammo_power>0)
     ammo_power--;
  // ammo pattern width
  if (ammo_powerup>0)
     ammo_powerup--;
}
/////////////////////////////
void Ship_Move(void){
  if (ship_exp==0){
    //take care of velocities
    ship_x = ship_x + ship.xvel;
    ship_y = ship_y + ship.yvel;
    if (ship.xvel>0){
      ship.xvel -= ship.xdec;
      if (ship.xvel<0) ship.xvel=0;
    }
    if (ship.xvel<0){
      ship.xvel += ship.xdec;
      if (ship.xvel>0) ship.xvel=0;
    }
    if (ship.yvel>0){
      ship.yvel -= ship.ydec;
      if (ship.yvel<0) ship.yvel=0;
    }
    if (ship.yvel<0){
      ship.yvel += ship.ydec;
      if (ship.yvel>0) ship.yvel=0;
    }

    //move ship
    if (key[KEY_LEFT]){
       ship_x-=ship_speed;
       if (ship_x<0) ship_x=0;
    }
    if (key[KEY_RIGHT]){
       ship_x+=ship_speed;
       if (ship_x>WIDTH-ship_width) ship_x=WIDTH-ship_width;
    }
    if (key[KEY_UP]){
       ship_y-=ship_speed;
       if (ship_y<32) ship_y=32;
    }
    if (key[KEY_DOWN]){
       ship_y+=ship_speed;
       if (ship_y>HEIGHT-ship_height-8) ship_y=HEIGHT-ship_height-8; // 8 if for scoreboard
    }
    //reduce invunerability
    if (ship_invun_count>0) ship_invun_count--;
//    if (ship_invun_count==0) stop_sample(gamesound[ship_invunsound]);
  }
  else {
    //explode ship
    if (ship_framecount<exp_anim_speed)
       ship_framecount++;
    else {
       ship_framecount=0;
       if (ship_exp<exp_frames[ship_exp_anim])
           ship_exp++;
       else{
          //lose a life
          lives--;
          Ship_Degrade();
          Ship_Init();
       }
    }
  } // end explode ship
}
/////////////////////////////
void Ship_Cycle(void){
    if (ship_framecount<4) ship_framecount++;
    else ship_framecount=0;

    if (ship_framecount==0){
       if (ship_coloffset<3) ship_coloffset++;
       else
          ship_coloffset=0;

       n=ship_coloffset;
       for (i=239;i>235;i--){
         set_color(i, &ship_col[n]);
         if (n<3) n++;
         else n=0;
       }
    }
}
/////////////////////////////
void Ship_Damage(void){
  if (ship_invun_count==0){
     //damage ship
     if (ship_hit==0) // otherwise ignore ship_hit
        ship_hit=1;
     if (ship_shield>0)
        ship_shield-=damage_shield;
     else
        ship_hull-=damage_hull;
     //deflect ship
     ship.xvel=2;
     ship.yvel=2;
//     ship_x+=fixtoi(((fsin(alien_angle[li])*alien_radius*alien_speed[li])-(fsin(alien_angle[li]-itofix(1))*alien_radius*alien_speed[li]))*2);
//     ship_y+=2;
     stop_sample(gamesound[ship_hitsound]);
     play_sample(gamesound[ship_hitsound],255,pan,400-ship_shield-ship_hull,FALSE);

     if (ship_hull<=0){
        //explode ship
        ship_shield=0;
        ship_exp=1;
        ship_framecount=0;
        stop_sample(gamesound[ship_expsound]);
        play_sample(gamesound[ship_expsound],255,pan,100,FALSE);
     }
  }
}
/////////////////////////////
int Pixel_Perfect_Collision(void){
  // externally set dx and dy ... dx = alien_x[li]-ship_x
  // externally set scan_alien_width = alien_sizex[li]
  // externally set both damage variables

  //calc checking rectangle parameters
  if (dx<0){
     //offset is on alien
     dx=0-dx; // make +ve
     scan_alienx=dx;
     scan_shipx=0;
     scan_width=scan_alienwidth-dx;
     if (scan_width>ship_width)
        scan_width=ship_width;
  }
  else{
     //offset is on ship
     scan_shipx=dx;
     scan_alienx=0;
     scan_width=ship_width-dx;
     if (scan_width>scan_alienwidth)
        scan_width=scan_alienwidth;
  }
  if (dy<0){
     //offset is on alien
     dy=0-dy; // make +ve
     scan_alieny=dy;
     scan_shipy=0;
     scan_height=scan_alienheight-dy;
     if (scan_height>ship_height)
        scan_height=ship_height;
  }
  else{
     //offset is on ship
     scan_shipy=dy;
     scan_alieny=0;
     scan_height=ship_height-dy;
     if (scan_height>scan_alienheight)
        scan_height=scan_alienheight;
  }

  // do the pixel perfect checking
  for (y=0;y<scan_height;y++){
      for (x=0;x<scan_width;x++)
          if (_getpixel(ship_bmp,scan_shipx+x,scan_shipy+y)>0&&
              _getpixel(test_bmp,scan_alienx+x,scan_alieny+y)>0)
              return(1);
  } // end main for loop
  return(0);
}
/////////////////////////////
int PP_Ammo_Collision(void){
  //set pixel perfect collision variables
  test_bmp=alien_bmp[alien_type[li]][alien_frame[li]];
  dx=alien_x[li]-ammo_x[ai];
  dy=alien_y[li]-ammo_y[ai];
  scan_alienwidth=alien_sizex[li];
  scan_alienheight=alien_sizey[li];
  pp_ammowidth=ammo_sizex[ai];
  pp_ammoheight=ammo_sizey[ai];

  //calc checking rectangle parameters
  if (dx<0){
     //offset is on alien
     dx=0-dx; // make +ve
     scan_alienx=dx;
     pp_ammox=0;
     scan_width=scan_alienwidth-dx;
     if (scan_width>pp_ammowidth)
        scan_width=pp_ammowidth;
  }
  else{
     //offset is on ship
     pp_ammox=dx;
     scan_alienx=0;
     scan_width=pp_ammowidth-dx;
     if (scan_width>scan_alienwidth)
        scan_width=scan_alienwidth;
  }
  if (dy<0){
     //offset is on alien
     dy=0-dy; // make +ve
     scan_alieny=dy;
     pp_ammoy=0;
     scan_height=scan_alienheight-dy;
     if (scan_height>pp_ammoheight)
        scan_height=pp_ammoheight;
  }
  else{
     //offset is on ship
     pp_ammoy=dy;
     scan_alieny=0;
     scan_height=pp_ammoheight-dy;
     if (scan_height>scan_alienheight)
        scan_height=scan_alienheight;
  }

  // do the pixel perfect checking
  for (y=0;y<scan_height;y++){
      for (x=0;x<scan_width;x++)
          if (_getpixel(ammo_bmp[ammo_type[ai]][ammo_powerlevel[ai]],pp_ammox+x,pp_ammoy+y)>0&&
              _getpixel(test_bmp,scan_alienx+x,scan_alieny+y)>0)
             return(1);
  }
  return(0);
}
/////////////////////////////
void Ammo_Init(void){
  for (i=0; i<MAX_AMMO; i++){
    ammo_stack[i]=0;
    ammo_alive[i]=0; // all ammo is dead
    ammo_type[i]=0;
    ammo_powerlevel[i]=0;
    ammo_sizex[i]=0;
    ammo_sizey[i]=0;
    ammo_framecount[i]=0;
    ammo_exp[i]=0;
    ammo_spread[i]=0;
    ammo_spread_errorterm[i]=0;
    ammo_spread_delta[i]=0;
    ammo_speed[i]=0;
  }
  ammo_stack_ptr=0;
}

/////////////////////////////
void Ammo_Create(void){
  //n=position in ammo pattern

  //find a free ammo slot
  for (i=0; i<MAX_AMMO; i++)
      if (ammo_alive[i]==0){
         //create new ammo
         ammo_alive[i]=1;
         ammo_type[i]=ship_ammotype;
         ammo_powerlevel[i]=ammo_power;
         ammo_sizex[i]=ammo_size[ammo_power];
         ammo_sizey[i]=ammo_size[ammo_power];
         ammo_framecount[i]=0;
         ammo_exp[i]=0;
         ammo_x[i]=ship_x+ammo_offsetx[ammo_power]+ammo_patternx[ammo_powerup][ammo_power*5+n];
         ammo_y[i]=ship_y+ammo_offsety[ammo_power]+ammo_patterny[ammo_powerup][ammo_power*5+n];
         if (autofire&&ammo_curspeed<8)
            num=8;
         else
            num=ammo_curspeed;
         ammo_y[i]+=num;
         ammo_speed[i]=num;
         ammo_spread[i]=ammo_type_spread[ammo_powerup][n];
         ammo_spread_errorterm[i]=0;
         ammo_spread_delta[i]=(ammo_speed[i]*70)/6;
         ammo_refire_counter=ammo_refirelevel;
         ammo_stack[ammo_stack_ptr]=i;
         ammo_stack_ptr++;
         break;
      }
}
/////////////////////////////
void Ammo_Move(void){
  //see if FIRE is pressed
  if (ammo_refire_counter>0)
      ammo_refire_counter--;
  if (key[KEY_CONTROL]&&ammo_stack_ptr<MAX_AMMO){
     if (ammo_refire_counter==0){
        ammo_control_hada0=0;
        //is autofire on ?
        if (autofire>0){
           autofire--;
           if (ammo_refirelevel>3) ammo_refirelevel--;
           if (ammo_pitch<260)
              ammo_pitch=ammo_pitch+ammo_pitchrise;
        }
        else{
           ammo_refirelevel=ammo_refirestart;
           ammo_pitch = ammo_pitchstart;
        }

        stop_sample(gamesound[ship_firesound]);
        play_sample(gamesound[ship_firesound], 255, pan, ammo_pitch, FALSE);
        //fill ammo pattern
        for (n=0; n<ammo_numammos[ammo_powerup]; n++){
          //create new ammo
          Ammo_Create();
        }
     }
  }
  else {
     ammo_control_hada0 = 1;
     ammo_pitch = ammo_pitchstart;
     ammo_refire_counter=0;
     ammo_refirelevel = ammo_refirestart;
  }

  //move all ammo
  for (i=0; i<ammo_stack_ptr; i++){ // NOTE: this loop may shrink as ammo_stack_ptr decreases
      ai=ammo_stack[i];
      //is ammo exploding ?
      if (ammo_exp[ai]>0){
         ammo_y[ai]-=1;
         if (ammo_framecount[ai]<exp_anim_speed)
            ammo_framecount[ai]++;
         else{
            ammo_framecount[ai]=0;
            index = ammo_type_exp[ammo_power];
            if (ammo_exp[ai]<exp_frames[index]-1)
               ammo_exp[ai]++;
            else{
               // take ammo out of stack
               ammo_exp[ai]=0;
               ammo_alive[ai]=0;
               ammo_stack_ptr--;
               //shuffle ammo_stack
               for (n=i;n<ammo_stack_ptr;n++) // it is supposed to be i and not ai
                   ammo_stack[n]=ammo_stack[n+1];
               i--; // very important otherwise the next ammo gets missed out
            }
         }
      } // end ammo exploding
      else{
         //ammo is ALIVE !
         ammo_y[ai]-=ammo_speed[ai];
         //should ammo be dead ?
         if (ammo_y[ai]<0-ammo_sizey[ai]){
            ammo_exp[ai]=1; // start it exploding .. effectively its dead
            ammo_framecount[ai]=0;
         }
         //is spread ammo active ?
         if (ammo_spread_enabled){
            ammo_spread_errorterm[ai]+=ammo_spread_delta[ai];
            while (ammo_spread_errorterm[ai]>70){
                  ammo_spread_errorterm[ai]-=70;
                  ammo_x[ai]+=ammo_spread[ai];
            }
         }
      }
  }
}
/////////////////////////////
void Init_Pows(void){
  for (i=0;i<MAX_POWS;i++){
    pow_alive[i]=0;
    pow_type[i]=0;
    pow_x[i]=0;
    pow_y[i]=0;
  }
  pow_framecount=0;
  pow_coloffset=0;

  last_pow=0;
  last_pow_col=0;
  last_pow_framecount=0;

  pow_col[0].r=24;
  pow_col[0].g=24;
  pow_col[0].b=24;
  pow_col[1].r=32;
  pow_col[1].g=32;
  pow_col[1].b=32;
  pow_col[2].r=48;
  pow_col[2].g=48;
  pow_col[2].b=48;
  pow_col[3].r=63;
  pow_col[3].g=63;
  pow_col[3].b=63;
}
/////////////////////////////
void Create_Pow(void){
  if (pow_cheat||rand()%(4*(ammo_power+ammo_powerup+1))==0)
  for (pow=0;pow<MAX_POWS;pow++)
    if (pow_alive[pow]==0){
      pow_alive[pow]=1;
      pow_type[pow]=rand()%9;
      if (rand()%5==0)
         pow_type[pow]=0; // bias autofire
      pow_x[pow]=alien_x[li]+(alien_sizex[li]-32)/2;
      pow_y[pow]=alien_y[li]+(alien_sizey[li]-32)/2;
      break;
    }
}
/////////////////////////////
void Pows_Move(void){
  for (i=0;i<MAX_POWS;i++){
    if (pow_alive[i]){
      pow_y[i]++;
      //has pow hit ship ?
      if (ship_exp==0&&(ship_x+ship_width)>pow_x[i]) // cant get pow if u are exploding
         if (ship_x<pow_x[i]+32)
            //test for y clash
            if ((ship_y+ship_height)>pow_y[i])
               if (ship_y<pow_y[i]+32){
                  //set pixel perfect collision variables
                  test_bmp=pow_bmp[pow_type[i]];
                  dx=pow_x[i]-ship_x;
                  dy=pow_y[i]-ship_y;
                  scan_alienwidth=32;
                  scan_alienheight=32;

                  if (Pixel_Perfect_Collision()==1){
                  play_sample(gamesound[ship_powsound],255,pan,250,FALSE);
                  //powerup ship !!
                  pow_alive[i]=0;
                  last_pow=pow_type[i];
                  last_pow_col=15; // white ... now on screen label will show
                  last_pow_framecount=0;

                  if (pow_type[i]==0){ // red = autofire + 100
                     stop_sample(gamesound[ship_invunsound]);
                     stop_sample(gamesound[ship_autosound]);
                     play_sample(gamesound[ship_autosound],255,pan,autofire_musicpitch,FALSE);
                     if (autofire==0){
                        ammo_control_hada0 = 1;
                        ammo_pitch = ammo_pitchstart;
                        ammo_refirelevel = ammo_refirestart;
                        ammo_refire_counter=ammo_refirelevel;
                     }
                     autofire+=100; // frames of firepower
                     if (autofire>max_autofire)
                       autofire=max_autofire;
                  }
                  if (pow_type[i]==1){ // green = shield + 50
                      ship_shield+=50;
                      if (ship_shield>max_shield)
                         ship_shield=max_shield;
                  }
                  if (pow_type[i]==2){ // blue = hull + 50
                      ship_hull+=50;
                      if (ship_hull>max_hull)
                         ship_hull=max_hull;
                  }
                  if (pow_type[i]==3) // magenta = ammo power increase
                    if (ammo_power<MAX_AMMO_POWER-1){
                      ammo_power++;
                    }
                  if (pow_type[i]==4) // cyan = ammo pattern increase
                    if (ammo_powerup<MAX_AMMO_POWERUP-1){
                      ammo_powerup++;
                    }
                  if (pow_type[i]==5) // yellow = ammo speed increase
                    if (ammo_curspeed<ammo_maxspeed){
                      ammo_curspeed+=2;
                    }
                  if (pow_type[i]==6){ // white = ammo spread shot
                     ammo_spread_enabled=1;
                  }
                  if (pow_type[i]==7){ // orange = invunerability
                     ship_invun_count=ship_invun_length;
                     ship_coloffset=0;
                     ship_framecount=0;
                     stop_sample(gamesound[ship_autosound]);
                     stop_sample(gamesound[ship_invunsound]);
                     play_sample(gamesound[ship_invunsound],255,pan,ship_invun_musicpitch,FALSE);
                  }
                  if (pow_type[i]==8) // light green = ship speed increase
                    if (ship_speed<ship_maxspeed){
                      ship_speed+=2;
                    // if ship is faster than ammo then speed up ammo
                    if (ship_speed>ammo_curspeed)
                       ammo_curspeed = ship_speed;
                    }
                  } // end if PPC==1
               }

      //has pow gone off screen ?
      if (pow_y[i]>HEIGHT) pow_alive[i]=0;
    }
  }
}
/////////////////////////////
void Pows_Cycle(void){
    if (pow_framecount<4) pow_framecount++;
    else pow_framecount=0;

    if (pow_framecount==0){
       if (pow_coloffset<3) pow_coloffset++;
       else pow_coloffset=0;
    }

    n=pow_coloffset;
    for (i=235;i>231;i--){
      set_color(i, &pow_col[n]);
      if (n<3) n++;
      else n=0;
    }
}
/////////////////////////////
// ALIEN AMMO
/////////////////////////////
void Alien_Ammo_Init(void){
  for (i=0;i<MAX_ALIEN_AMMO;i++){
      aa_x[i]=0;
      aa_y[i]=0;
      aa_dx[i]=0;
      aa_dy[i]=0;
      aa_ex[i]=0;
      aa_ey[i]=0;
      aa_ecx[i]=0;
      aa_ecy[i]=0;
      aa_xdir[i]=0;
      aa_ydir[i]=0;
      aa_alive[i]=0;
      aa_type[i]=0;
      aa_sizex[i]=0;
      aa_sizey[i]=0;
      aa_frame[i]=0;
      aa_framecount[i]=0;
      aa_exp[i]=0;
      aa_speed[i]=0;
  }
}
/////////////////////////////
void Alien_Ammo_Create(void){
  if (at_ammo[alien_type[li]]==-1) return;
  //search through array for blank slot
  for (aa=0;aa<MAX_ALIEN_AMMO;aa++)
      if (aa_alive[aa]==0){
         // create alien ammo
         aa_alive[aa]=1;
         aa_type[aa]=at_ammo[alien_type[li]];
         aa_sizex[aa]=aa_type_sizex[aa_type[aa]];
         aa_sizey[aa]=aa_type_sizey[aa_type[aa]];
         aa_frame[aa]=0;
         aa_framecount[aa]=0;
         aa_exp[aa]=0;
         aa_speed[aa]=at_ammo_speed[alien_type[li]];
         aa_stack[aa_stack_ptr]=aa;
         aa_stack_ptr++;

         //calc trajectory
         aa_x[aa]=alien_x[li]+alien_sizex[li]/2-aa_sizex[aa]/2;
         aa_y[aa]=alien_y[li]+alien_sizey[li]/2-aa_sizey[aa]/2;
         aa_dx[aa]=ship_x+16-aa_x[aa];
         aa_dy[aa]=ship_y+16-aa_y[aa];
         if (aa_dx[aa]<0){
            aa_dx[aa]=0-aa_dx[aa];
            aa_xdir[aa]=-1;
         }
         else
            aa_xdir[aa]=1;
         if (aa_dy[aa]<0){
            aa_dy[aa]=0-aa_dy[aa];
            aa_ydir[aa]=-1;
         }
         else
            aa_ydir[aa]=1;
         adx = itofix(aa_dx[aa])/1000;
         ady = itofix(aa_dy[aa])/1000;
         hyp = ((fsqrt(fmul(adx,adx)+fmul(ady,ady)))*1000)/aa_speed[aa];
         if (hyp==itofix(0)) hyp=itofix(1);
         aa_ex[aa]=0;
         aa_ey[aa]=0;
         aa_ecx[aa]=fixtoi(hyp);
         aa_ecy[aa]=fixtoi(hyp);

         stop_sample(gamesound[at_firesound[alien_type[li]]]);
         play_sample(gamesound[at_firesound[alien_type[li]]],255,pan,200,FALSE);
         break;
      }
}
/////////////////////////////
void Alien_Ammo_Move(void){
  for (aa=0;aa<aa_stack_ptr;aa++){
      aai=aa_stack[aa];
      // move on animation frame
      if (aa_framecount[aai]<aa_anim_speed)
         aa_framecount[aai]++;
      else{
         aa_framecount[aai]=0;
         if (aa_frame[aai]<aa_tframes[aa_type[aai]]-1)
            aa_frame[aai]++;
         else
            aa_frame[aai]=0;
      }

      //go to ships old coords
//      if (aa_type[aai]==1000){
         aa_ex[aai]+=aa_dx[aai];
         while (aa_ex[aai]>aa_ecx[aai]){
               aa_ex[aai]-=aa_ecx[aai];
               aa_x[aai]+=aa_xdir[aai];
         }
         aa_ey[aai]+=aa_dy[aai];
         while (aa_ey[aai]>aa_ecy[aai]){
               aa_ey[aai]-=aa_ecy[aai];
               aa_y[aai]+=aa_ydir[aai];
         }
        if (framecount==0) aa_y[aai]++;
//      }

      //chase ship
      if (aa_type[aai]==100){
         if (aa_x[aai]<ship_x)
            aa_x[aai]++;
         if (aa_x[aai]>ship_x)
            aa_x[aai]--;
         if (aa_y[aai]<ship_y)
            aa_y[aai]++;
         if (aa_y[aai]>ship_y)
            aa_y[aai]--;
      }

      //is alien ammo exploding ?
      if (aa_exp[aai]>0){
         if (aa_framecount[aai]<exp_anim_speed)
            aa_framecount[aai]++;
         else{
            aa_framecount[aai]=0;
            index = 0;
            if (aa_exp[aai]<exp_frames[index])
               aa_exp[aai]++;
            else{
               //take alien out of stack
               aa_exp[aai]=0;
               aa_alive[aai]=0;
               aa_stack_ptr--;
               //shuffle alien ammo_stack
               for (n=aa;n<aa_stack_ptr;n++) // it is supposed to be aa and not aai
                   aa_stack[n]=aa_stack[n+1];
               aa--; // very important otherwise the next alien ammo gets missed out
            }
         }
      }
      //alien ammo is ALIVE !
      else{
         // has alien ammo bumped into ship?
         if (ship_exp==0) // only test if ship is alive
            if ((ship_x+ship_width)>aa_x[aai]+ship_leeway)
                if (ship_x+ship_leeway<aa_x[aai]+aa_sizex[aai])
                   //test for y clash
                   if ((ship_y+ship_height)>aa_y[aai]+ship_leeway)
                      if (ship_y+ship_leeway<aa_y[aai]+aa_sizey[aai]){
                         //set pixel perfect collision variables
                         test_bmp=aa_bmp[aa_type[aai]][aa_frame[aai]];
                         dx=aa_x[aai]-ship_x;
                         dy=aa_y[aai]-ship_y;
                         scan_alienwidth=aa_sizex[aai];
                         scan_alienheight=aa_sizey[aai];

                         if (Pixel_Perfect_Collision()==1){
                            damage_shield=aa_damage_shield[aa_type[aai]];
                            damage_hull=aa_damage_hull[aa_type[aai]];
                            Ship_Damage();
                            //kill alien ammo
                            aa_exp[aai]=1;
                            aa_framecount[aai]=0;
                            if (ship_invun_count>0){ // only play sound if ship is invunerable
                               stop_sample(gamesound[at_expsound[alien_type[li]]]);
                               play_sample(gamesound[at_expsound[alien_type[li]]],255,pan,120,FALSE);
                            }
                         }
                      }

         //kill alien ammo
         if (aa_x[aai]>WIDTH+32||aa_x[aai]<0-32||aa_y[aai]>HEIGHT||aa_y[aai]<0-32){
            aa_exp[aai]=0;
            aa_alive[aai]=0;
            aa_stack_ptr--;
            //shuffle alien ammo_stack
            for (n=aa;n<aa_stack_ptr;n++) // it is supposed to be aa and not aai
                 aa_stack[n]=aa_stack[n+1];
            aa--; // very important otherwise the next alien ammo gets missed out
         }
      }
  }
}
/////////////////////////////
// ALIENS
/////////////////////////////
void Aliens_Init(void){
  for (i=0; i<MAX_ALIENS; i++){
    alien_stack[i]=0;
    alien_type[i]=0;
    alien_sizex[i]=0;
    alien_sizey[i]=0;
    alien_frame[i]=0;
    alien_framecount[i]=0;
    alien_alive[i]=0; // all aliens are dead
    alien_energy[i]=0;
    alien_hit[i]=0;
    alien_hitcount[i]=0;
    alien_exp[i]=0;
    alien_speed[i]=0;
    alien_angle[i]=itofix(0);
  }
  alien_stack_ptr=0;
}
/////////////////////////////
void Create_Alien(void){
  //find a free alien slot
  for (i=0; i<MAX_ALIENS; i++)
    if (alien_alive[i]==0){
      //create an alien
      alien_type[i]=rand()%MAX_ALIEN_TYPES;
      alien_sizex[i]=asx[alien_type[i]];
      alien_sizey[i]=asy[alien_type[i]];
      alien_frame[i]=0;
      alien_framecount[i]=0;
      alien_alive[i]=1;
      alien_energy[i]=alien_type_energy[alien_type[i]];
      alien_hit[i]=0;
      alien_hitcount[i]=0;
      alien_exp[i]=0;
      alien_startx[i]=rand()%(WIDTH-alien_radius);
      alien_y[i]=-alien_sizey[i];
      alien_speed[i]=rand()%4;
      alien_angle[i]=itofix(random()%255);
      alien_stack[alien_stack_ptr]=i;
      alien_stack_ptr++;
      break;
  }
}
/////////////////////////////
void Aliens_Move(void){
  // create new alien ?
  if (key[KEY_A]&&alien_stack_ptr<MAX_ALIENS)
     Create_Alien();
  if (rand()%(100/(ammo_power+ammo_powerup+1))==0)
     Create_Alien();

  //move all aliens
  for (i=0;i<alien_stack_ptr;i++){  // NOTE: this loop may shrink as alien_stack_ptr decreases
    li=alien_stack[i];
    //move alien
    alien_x[li]=alien_startx[li]+fixtoi(fsin(alien_angle[li])*alien_radius*alien_speed[li]);
    alien_y[li]=alien_y[li]+1;
    alien_angle[li]+=itofix(1);
    //is alien off screen ?
    if (alien_y[li]>HEIGHT){
       //take alien out of stack
       alien_energy[li]=0;
       alien_framecount[li]=0;
       alien_exp[li]=0;
       alien_alive[li]=0;
       alien_stack_ptr--;
       //shuffle alien_stack
       for (n=i;n<alien_stack_ptr;n++)
           alien_stack[n]=alien_stack[n+1];
       i--; // very important otherwise the next alien gets missed out
    }
    else
// EXPLODE ALIEN
    //is alien in the exploding animation ?
    if (alien_exp[li]>0){
       if (alien_framecount[li]<exp_anim_speed)
          alien_framecount[li]++;
       else{
          alien_framecount[li]=0;
          index = alien_type_exp[alien_type[li]];
          if (alien_exp[li]<exp_frames[index])
             alien_exp[li]++;
          else{
             //take alien out of stack
             alien_exp[li]=0;
             alien_alive[li]=0;
             alien_stack_ptr--;
             //shuffle alien_stack
             for (n=i;n<alien_stack_ptr;n++)
                 alien_stack[n]=alien_stack[n+1];
             i--; // very important otherwise the next alien gets missed out
         }
       }
    }
    else{
// ALIEN -> AMMO COLLISION DETECTION
      //is alien hit ?
      offsetx = ammo_sizex[ai];
      offsety = ammo_sizey[ai];
      for (index=0; index<ammo_stack_ptr; index++){
        ai=ammo_stack[index];
        // only test if ammo is NOT exploding
        if (ammo_exp[ai]==0&&ammo_x[ai]+offsetx>alien_x[li])
           if (ammo_x[ai]<alien_x[li]+alien_sizex[li])
              //test for y clash
              if ((ammo_y[ai]+offsety)>alien_y[li])
                 if (ammo_y[ai]<alien_y[li]+alien_sizey[li]){
                    //Pixel Perfect Ammo->Alien collision
                    if (PP_Ammo_Collision()==1){
                       //kill ammo that killed alien
                       ammo_exp[ai]=1;
                       ammo_framecount[ai]=0;

                       //damage alien
                       alien_energy[li]-=ammo_powerlevel[ai]+1;
                       alien_hit[li]=1;
                       alien_hitcount[li]=0; // this is used to delay how long alien hit is showing
                       alien_y[li]-=2;
                       if (alien_energy[li]<=0){
                          //set alien explode counter
                          score+=100;
                          stop_sample(gamesound[at_expsound[alien_type[li]]]);
                          play_sample(gamesound[at_expsound[alien_type[li]]],255,pan,120,FALSE);
                          alien_exp[li]=1;
                          alien_framecount[li]=0;
                          Create_Pow();
                          break; // only break out of ammo loop if alien is dead
                       }
                    score+=10;
                    stop_sample(gamesound[at_hitsound[alien_type[li]]]);
                    play_sample(gamesound[at_hitsound[alien_type[li]]],255,pan,200,FALSE);
                    } // end if collision
                 }
      } // end for ammo loop
     //is alien alive and healthy ?
      if (alien_energy[li]>0){
// ALIEN IS ALIVE
       // has alien bumped into ship?
         if (ship_exp==0) // only test if ship is alive
            if ((ship_x+ship_width)>alien_x[li]+ship_leeway)
                if (ship_x+ship_leeway<alien_x[li]+alien_sizex[li])
                   //test for y clash
                   if ((ship_y+ship_height)>alien_y[li]+ship_leeway)
                      if (ship_y+ship_leeway<alien_y[li]+alien_sizey[li]){
                         //set pixel perfect collision variables
                         test_bmp=alien_bmp[alien_type[li]][alien_frame[li]];
                         dx=alien_x[li]-ship_x;
                         dy=alien_y[li]-ship_y;
                         scan_alienwidth=alien_sizex[li];
                         scan_alienheight=alien_sizey[li];

                         if (Pixel_Perfect_Collision()==1){
                            damage_shield=alien_damage_shield;
                            damage_hull=alien_damage_hull;
                            Ship_Damage();
                            // damage alien
                            if (alien_hit[li]==0){
                               alien_energy[li]--;
                               alien_hit[li]=1;
                               alien_hitcount[li]=0; // this is used to delay how long alien hit is showing
                               alien_starty[li]-=4;
                               if (alien_energy[li]<=0){
                                  //set alien explode counter
                                  score+=100;
                                  stop_sample(gamesound[at_expsound[alien_type[li]]]);
                                  play_sample(gamesound[at_expsound[alien_type[li]]],255,pan,120,FALSE);
                                  alien_exp[li]=1;
                                  alien_framecount[li]=0;
                                  Create_Pow();
                               }
                            }
                            score+=10;
                            if (ship_invun_count>0){ // only play alien damage sound if ship is invunerable
                               stop_sample(gamesound[at_hitsound[alien_type[li]]]);
                               play_sample(gamesound[at_hitsound[alien_type[li]]],255,pan,200,FALSE);
                            }
                         }
                      }

         // is alien hit ? .. should it be unhit yet ?
         if (alien_hit[li]){
            if (alien_hitcount[li]<alien_hit_speed)
               alien_hitcount[li]++;
            else{
               alien_hitcount[li]=0;
               alien_hit[li]=0;
            }
         }
         // move alien animation frame on one as alien is still alive
         if (alien_framecount[li]<alien_anim_speed[alien_type[li]])
            alien_framecount[li]++;
         else{
            alien_framecount[li]=0;
            if (alien_frame[li]<alien_frames[alien_type[li]]-1)
               alien_frame[li]++;
            else
               alien_frame[li]=0;
         }

         // has alien fired ?
         if (rand()%alien_firerate==0&&aa_stack_ptr<MAX_ALIEN_AMMO)
            Alien_Ammo_Create();

      } // end if alien is alive
    } // end big else
  }
}
/////////////////////////////
void Test_Keys(void){
    //pause loop
    do{
      if (keypressed()) lastkey = readkey()>>8;
      else lastkey = 0;
      //exit demo if ESCAPE is pressed
      if (lastkey == KEY_ESC){
        Game_Exit();
        printf("Program Exit OK: User pressed Escape\n\n");
        exit(0);
      }
      //test pause key
      if (key[KEY_P]){
        if (paused_hada0==1)
        if (paused==0){
          paused=1;
          paused_hada0=0;
          if (show_raster) set_color(0, &col_black);
          textout(screen,font,"< PAUSED >",WIDTH/2-40,HEIGHT/2-4,15);
        }
        else {
          paused=0;
          paused_hada0=0;
        }
      }
      else paused_hada0=1;
      //test CONTROL key ... it gets out of pause
      if (key[KEY_CONTROL]){
        if (paused_control_hada0==1){
          paused=0;
          paused_control_hada0=0;
        }
      }
      else paused_control_hada0=1;
    } while (paused==1);

    //show raster timer ?
    if (key[KEY_R]){
       if (keyr_hada0==1){
          keyr_hada0=0;
          show_raster= ~show_raster; // toggle
       }
    }
    else
       keyr_hada0=1;

    //slow motion ?
    if (lastkey==KEY_S){
      if (slow_motion<3)
         slow_motion++;
      else
         slow_motion=0;
    }

    if (lastkey==KEY_W)
       pow_cheat=~pow_cheat;

    //change ammo power
    if (key[KEY_F1]) ammo_power=0;
    if (key[KEY_F2]) ammo_power=1;
    if (key[KEY_F3]) ammo_power=2;
    if (key[KEY_F4]) ammo_power=3;

    //change ammo_type
    if (key[KEY_F5]) ship_ammotype=0;
    if (key[KEY_F6]) ship_ammotype=1;
    if (key[KEY_F7]) ship_ammotype=2;
    if (key[KEY_F8]) ship_ammotype=3;

    //change ammo powerup
    if (key[KEY_1]) ammo_powerup=0;
    if (key[KEY_2]) ammo_powerup=1;
    if (key[KEY_3]) ammo_powerup=2;
    if (key[KEY_4]) ammo_powerup=3;
    if (key[KEY_5]) ammo_powerup=4;
}
/////////////////////////////
void Verify_Files(void){
  //Check if pcxs file exist in current directory.
  if ( (file_exists (pcx_name, 32, NULL) ) == 0) {
    printf ("Program Exit BAD: File %s not found\n\n", pcx_name);
    exit (1);
  }
  if ( (file_exists (exp_pcx_name, 32, NULL) ) == 0) {
    printf ("Program Exit BAD: File %s not found\n\n", exp_pcx_name);
    exit (1);
  }
  if ( (file_exists (alien_pcx_name, 32, NULL) ) == 0) {
    printf ("Program Exit BAD: File %s not found\n\n", alien_pcx_name);
    exit (1);
  }

  //Check if sample files exist in current directory.
  for (i=0; i<MAX_SAMPLES; i++)
  if ( (file_exists (sample_name[i], 32, NULL) ) == 0) {
    printf ("Program Exit BAD: File %s not found\n\n", sample_name[i]);
    exit (1);
  }
}
/////////////////////////////
void Load_Files(void){
FILE *fp;
int ch=65;

  if ((fp=fopen(fname,"rb"))==NULL){
     allegro_exit();
     printf("Program Exit BAD: Cannot open file %s\n\n", fname);
     exit(1);
  }

  map_ptr = map;
  while (!feof(fp)) *map_ptr++ =getc(fp);

  *--map_ptr=0; // terminate string
  fclose(fp);

   //Load pcx files into various buffers
   exp_buffer = load_pcx(exp_pcx_name, pcx_pallete);
   alien_buffer = load_pcx(alien_pcx_name, pcx_pallete);
   pcx_buffer = load_pcx(pcx_name, pcx_pallete);

   //Load tiles pcx file into tiles buffer
   tiles = load_pcx(tiles_name, tiles_pallete);

   //Load samples ... 16-bit mono wav files
   for (i=0;i<MAX_SAMPLES;i++){
       gamesound[i] = load_sample(sample_name[i]);
       if (!gamesound[i]){
          allegro_exit();
          printf("Program Exit BAD: Error reading WAV file '%s'\n\n", sample_name[i]);
          exit(1);
       }

   }

   //install a digital sound driver
   if (install_sound(DIGI_AUTODETECT, MIDI_NONE, NULL)){
      allegro_exit();
      printf("Program Exit BAD: Error initialising sound system\n%s\n\n", allegro_error);
      exit(1);
   }

}
/////////////////////////////
void Print_Scoreboard(void){

    cx=0; cy=200-8;

    //hull bar
    for (i=0;i<48;i++){
      n=(i*max_hull)/48;
      if (n<ship_hull)
         for (loop=0; loop<6; loop++){
             col = 38-(i/8+1);
             _putpixel(scr,cx+i,cy+loop+1,col);}
      else
         for (loop=0; loop<6; loop++)
             _putpixel(scr,cx+i,cy+loop+1,0);
      _putpixel(scr,cx+i,cy,15-i/4);
      _putpixel(scr,cx+i,cy+7,15-i/4);
    }
    cx+=8*6;

    //shield bar
    for (i=0;i<48;i++){
      n=(i*max_shield)/48;
      if (n<ship_shield)
         for (loop=0; loop<6; loop++){
             col = 30-(i/8+1);
             _putpixel(scr,cx+i,cy+loop+1,col);}
      else
         for (loop=0; loop<6; loop++)
             _putpixel(scr,cx+i,cy+loop+1,0);
      _putpixel(scr,cx+i,cy,15-i/4);
      _putpixel(scr,cx+i,cy+7,15-i/4);
    }
    cx+=8*6;

    textout(scr,font,"                ",cx,cy,1); // 16 spaces
    //show last pow label ?
    if (last_pow_col>0){
      //draw label
      textout_centre(scr,font,last_pow_string[last_pow],cx+8*8,cy,last_pow_col);
      //move on framecounter to fade colour
      if (last_pow_framecount<last_pow_speed)
         last_pow_framecount++;
      else{
         last_pow_framecount=0;
         last_pow_col--; // until it is 0
      }
    }
    cx+=8*16;

    //autofire bar ... 48 = 8*6
    for (i=0;i<48;i++){
      n=(i*max_autofire)/48;
      if (n<autofire)
         for (loop=0; loop<6; loop++){
             col = 22-(i/8+1);
             _putpixel(scr,cx+i,cy+loop+1,col);}
      else
         for (loop=0; loop<6; loop++)
             _putpixel(scr,cx+i,cy+loop+1,0);
      _putpixel(scr,cx+i,cy,15-i/4);
      _putpixel(scr,cx+i,cy+7,15-i/4);
    }
    cx+=8*6;
    itoa(score,itoa_str,10);
    textout(scr,font,itoa_str,cx,cy,48); cx+=8*8;
//    textout(scr,font,"Lives:",cx,cy,40); cx+=8*6;
//    itoa(lives,itoa_str,10);
//    textout(screen,font,itoa_str,cx,cy,48); cx+=8*1;
//    sprintf(buf,"%f",fixtof(result));
//    textout(screen,font,"             ",400,8,1);
//    textout(screen,font,buf,400,8,1); cy+=8;
}
/////////////////////////////
void Intro(void){

  BITMAP *test;
  BITMAP *test2;
  unsigned char colbyte=0;
  unsigned char offsetbyte=0;

  float seconds=0;
  float copysize=0; // in mb
  float mbpersec=0;

  char buf[64];      // used to store output of sprintf function

  ///////////////////////////
  //INTRO SCREEN
  cx=WIDTH/2;
  cy=50;
  textout_centre(screen,font,"WELCOME",cx,cy,15); cy+=16;
  textout_centre(screen,font,"TO",cx,cy,15); cy+=16;
  textout_centre(screen,font,"WING WANG",cx,cy,15); cy+=16;

  cy=160;
  textout_centre(screen,font,"PRESS <T> TO TEST YOUR SYSTEM",cx,cy,15); cy+=16;
  textout_centre(screen,font,"PRESS <SPACE> TO START",cx,cy,15); cy+=16;

  while (!keypressed()) ; // wait for any key press
  lastkey = readkey()>>8;

  if (lastkey!=KEY_T) return;

  ///////////////////////////
  //VIDEO SPEED TEST
  clear(screen);
  test = create_bitmap(WIDTH,HEIGHT);
  clear(test);

  //draw colour bars on test bitmap
  n = 0;
  for (y=0;y<HEIGHT;y++){
      colbyte=n;
      n++;
      for (x=0;x<WIDTH;x++){
          putpixel(test,x,y,colbyte);
          colbyte++;
      }
  }

  cx=WIDTH/2;
  cy=50;
  textout_centre(test,font,"VIDEO SPEED TEST",cx,cy,15); cy+=16;

  //do the test
  last_ticks=biostime(0,0);
  for (i=0; i<testvideo_loop; i++)
      blit(test,screen,0,0,0,0,WIDTH,HEIGHT);
  ticks=biostime(0,0);
  textout_centre(screen,font,"DONE",cx,cy,15); cy+=16;

  //show results
  for (y=cy;y<cy+64;y+=8) // draw a blank square
      textout_centre(screen,font,"                     ",cx,y,0); // 21 spaces
  cy+=4;
  x=WIDTH/2-8*10;
  textout_centre(screen,font,"RESULTS",cx,cy,15); cy+=16;
  cx=x;
  textout(screen,font,"Num Copies = ",cx,cy,15); cx+=13*8;
  itoa(testvideo_loop,itoa_str,10);
  textout(screen,font,itoa_str,cx,cy,15); cy+=8;
  cx=x;
  seconds=(ticks-last_ticks)/18.2;
  sprintf(buf,"%.2f",seconds);
  textout(screen,font,"Time Taken = ",cx,cy,15); cx+=13*8;
  textout(screen,font,buf,cx,cy,15); cy+=8;
  cx=x;
  copysize=(testvideo_loop*WIDTH*HEIGHT)/1024.0/1024.0; // value is in mb
  mbpersec=copysize/seconds;
  sprintf(buf,"%.2f",mbpersec);
  textout(screen,font,"Mb per Sec = ",cx,cy,15); cx+=13*8;
  textout(screen,font,buf,cx,cy,15); cy+=8;

  cx=WIDTH/2;
  cy=180;
  textout_centre(screen,font,"PRESS ANY KEY",cx,cy,15); cy+=16;

  while (!keypressed()) ; // wait for any key press
  lastkey = readkey();

  ///////////////////////////
  //CPU TEST
  clear(screen);

  //draw colour bars on test bitmap
  n = 0;
  for (y=0;y<HEIGHT;y++){
      colbyte=n;
      n--;
      for (x=0;x<WIDTH;x++){
          putpixel(test,x,y,colbyte);
          colbyte++;
      }
  }

  cx=WIDTH/2;
  cy=50;
  textout_centre(test,font,"CPU TEST",cx,cy,15); cy+=16;
  blit(test,screen,0,0,0,0,WIDTH,HEIGHT);

  //do test
  offsetbyte=0;
  last_ticks=biostime(0,0);
  for (i=0; i<testcpu_loop; i++){
      //draw colour bars on test bitmap
      n = 0;
      for (y=0;y<HEIGHT;y++){
          colbyte=n+offsetbyte;
          n--;
          for (x=0;x<WIDTH;x++){
              putpixel(test,x,y,colbyte);
              colbyte++;
          }
      }
      offsetbyte++;
      }
  ticks=biostime(0,0);
  textout_centre(screen,font,"DONE",cx,cy,15); cy+=16;

  //show results
  for (y=cy;y<cy+64;y+=8) // draw a blank square
      textout_centre(screen,font,"                     ",cx,y,0); // 21 spaces
  cy+=4;
  x=WIDTH/2-8*10;
  textout_centre(screen,font,"RESULTS",cx,cy,15); cy+=16;
  cx=x;
  textout(screen,font,"Num Copies = ",cx,cy,15); cx+=13*8;
  itoa(testcpu_loop,itoa_str,10);
  textout(screen,font,itoa_str,cx,cy,15); cy+=8;
  cx=x;
  seconds=(ticks-last_ticks)/18.2;
  sprintf(buf,"%.2f",seconds);
  textout(screen,font,"Time Taken = ",cx,cy,15); cx+=13*8;
  textout(screen,font,buf,cx,cy,15); cy+=8;
  cx=x;
  copysize=(testcpu_loop*WIDTH*HEIGHT)/1024.0/1024.0; // value is in mb
  mbpersec=copysize/seconds;
  sprintf(buf,"%.2f",mbpersec);
  textout(screen,font,"Mb per Sec = ",cx,cy,15); cx+=13*8;
  textout(screen,font,buf,cx,cy,15); cy+=8;

  cx=WIDTH/2;
  cy=180;
  textout_centre(screen,font,"PRESS ANY KEY",cx,cy,15); cy+=16;

  while (!keypressed()) ; // wait for any key press
  lastkey = readkey();

  ///////////////////////////
  //COMBINED TEST
  clear(screen);
  test2 = create_bitmap(WIDTH,HEIGHT);
  clear(test2);

  //draw colour bars on test bitmap
  n = 0;
  for (y=0;y<HEIGHT;y++){
      colbyte=n;
      n++;
      for (x=0;x<WIDTH;x++){
          putpixel(test,x,y,colbyte);
          colbyte++;
      }
  }

  //do test
  offsetbyte=0;
  last_ticks=biostime(0,0);
  for (i=0; i<testcpu_loop; i++){
      //draw colour bars on test bitmap
      n = 0;
      for (y=0;y<HEIGHT;y++){
          colbyte=n+offsetbyte;
          n++;
          for (x=0;x<WIDTH;x++){
              putpixel(screen,x,y,colbyte);
              colbyte++;
          }
      }
      offsetbyte++;
      }
  ticks=biostime(0,0);

  cx=WIDTH/2;
  cy=50;
  textout_centre(screen,font,"COMBINED TEST",cx,cy,15); cy+=16;
  textout_centre(screen,font,"DONE",cx,cy,15); cy+=16;

  //show results
  for (y=cy;y<cy+64;y+=8) // draw a blank square
      textout_centre(screen,font,"                     ",cx,y,0); // 21 spaces
  cy+=4;
  x=WIDTH/2-8*10;
  textout_centre(screen,font,"RESULTS",cx,cy,15); cy+=16;
  cx=x;
  textout(screen,font,"Num Copies = ",cx,cy,15); cx+=13*8;
  itoa(testcpu_loop,itoa_str,10);
  textout(screen,font,itoa_str,cx,cy,15); cy+=8;
  cx=x;
  seconds=(ticks-last_ticks)/18.2;
  sprintf(buf,"%.2f",seconds);
  textout(screen,font,"Time Taken = ",cx,cy,15); cx+=13*8;
  textout(screen,font,buf,cx,cy,15); cy+=8;
  cx=x;
  copysize=(testcpu_loop*WIDTH*HEIGHT)/1024.0/1024.0; // value is in mb
  mbpersec=copysize/seconds;
  sprintf(buf,"%.2f",mbpersec);
  textout(screen,font,"Mb per Sec = ",cx,cy,15); cx+=13*8;
  textout(screen,font,buf,cx,cy,15); cy+=8;

  cx=WIDTH/2;
  cy=180;
  textout_centre(screen,font,"PRESS ANY KEY",cx,cy,15); cy+=16;

  while (!keypressed()) ; // wait for any key press
  lastkey = readkey();

  destroy_bitmap(test);
}
/////////////////////////////
// MAIN
/////////////////////////////
void DebugStart(){

}
/////////////////////////////
void Debug(){
    cx=0;
    cy=0;
    textout(scr,font,map,cx,cy,15);
}
/////////////////////////////
void main()
{ int done = 0; // used to keep main loop going

  Verify_Files(); // see if all game files exist

  //SETUP
  allegro_init();
  install_keyboard();
   
  if (set_gfx_mode(GFX_AUTODETECT, WIDTH, HEIGHT, 0, 0)!=0)
  { printf("Program Exit BAD: Failed to set Graphics Resolution 320x200\n%s\n\n", allegro_error);
    exit(1);
  }

  Intro();
  Load_Files();
  Grab_Sprites();

  scr = create_bitmap(WIDTH,HEIGHT*2);
  set_pallete (pcx_pallete);
  clear(scr);
  blit(tiles,scr,0,0,0,0,WIDTH,HEIGHT*2);

  Game_Start();
  Ship_Init();
  Ammo_Init();
  Aliens_Init();
  Init_Pows();
  Alien_Ammo_Init();
  DebugStart();

  //MAIN LOOP
  while (!done)
  {
    Test_Keys();
    if (show_raster) set_color(0, &col_purple);
    Ship_Move();
    Ammo_Move();
    Aliens_Move();
    Pows_Move();
    Alien_Ammo_Move();
    Draw_Sprites();
    if (show_raster) set_color(0, &col_blue);
    Print_Scoreboard();

    Debug();

    //NEW FRAME
    set_color(0, &col_black);
    framecount++;
    if (framecount>1) framecount=0;
    vsync();
    //slow motion
    for (i=0;i<slow_motion;i++)
      vsync();
    if (slow_motion>0){
       itoa(slow_motion,itoa_str,10);
       textout(scr,font,"SPEED ",0,0,15);
       textout(scr,font,itoa_str,6*8,0,15);
    }

    Pows_Cycle();
    Ship_Cycle();

    //blit screen buffer onto screen
    if (show_raster) set_color(0, &col_red);
    blit(scr,screen,0,0,0,0,WIDTH,HEIGHT);
    if (show_raster) set_color(0, &col_green);
    blit(tiles,scr,0,scroll_y,0,0,WIDTH,HEIGHT);

    if (framecount==0) scroll_y--;
    if (scroll_y<0) scroll_y=6*32-1;

    //    Show_FPS();
  } // end MAIN LOOP

  //EXIT
  Game_Exit();
  exit(0);
}

